Loading...
Searching...
No Matches
itk::AdvancedLinearInterpolateImageFunction< TInputImage, TCoordRep > Class Template Reference

`#include <itkAdvancedLinearInterpolateImageFunction.h>`

## Detailed Description

template<class TInputImage, class TCoordRep = double>
class itk::AdvancedLinearInterpolateImageFunction< TInputImage, TCoordRep >

Linearly interpolate an image at specified positions.

AdvancedLinearInterpolateImageFunction linearly interpolates image intensity at a non-integer pixel position. This class is templated over the input image type and the coordinate representation type (e.g. float or double).

This function works for N-dimensional images.

This function works for images with scalar and vector pixel types, and for images of type VectorImage.

Unlike the LinearInterpolateImageFunction, which implements a constant boundary condition, this class implements a mirroring boundary condition, which mimics the BSplineInterpolateImageFunction.

Edge cases, i.e. points exactly on the right most edge of the image, need to be dealt with separately. In this implementation we subtract a small number from the continuous index and interpolate at that position. Alternatively, you would need to implement 7 different possibilities in 3D, e.g.: x[0] is at end index -> interpolate in x-y plane x[0] and x[1] are at end index -> interpolate along z line all are at end index -> nearest neighbor interpolation We opt to subtract a small number from x, which is computationally efficient, gives cleaner code, and almost exactly the same interpolated value.

See also
  VectorAdvancedLinearInterpolateImageFunction

\wiki \wikiexample{ImageProcessing/LinearInterpolateImageFunction,Linearly interpolate a position in an image} \endwiki

Definition at line 63 of file itkAdvancedLinearInterpolateImageFunction.h.

Inheritance diagram for itk::AdvancedLinearInterpolateImageFunction< TInputImage, TCoordRep >:
[legend]

## Data Structures

struct | Dispatch
struct | DispatchBase

## Public Types

using | ConstPointer = SmartPointer<const Self>
using | ContinuousIndexValueType = typename ContinuousIndexType::ValueType
using | CovariantVectorType = CovariantVector<OutputType, Self::ImageDimension>
using | InputImageSpacingType = typename InputImageType::SpacingType
using | Pointer = SmartPointer<Self>
using | Self = AdvancedLinearInterpolateImageFunction
using | Superclass = LinearInterpolateImageFunction<TInputImage, TCoordRep>

## Public Member Functions

CovariantVectorType | EvaluateDerivativeAtContinuousIndex (const ContinuousIndexType &x) const
void | EvaluateValueAndDerivativeAtContinuousIndex (const ContinuousIndexType &x, OutputType &value, CovariantVectorType &deriv) const
virtual const char * | GetClassName () const
| ITK_DISALLOW_COPY_AND_MOVE (AdvancedLinearInterpolateImageFunction)
| itkStaticConstMacro (ImageDimension, unsigned int, Superclass::ImageDimension)

## Static Public Member Functions

static Pointer | New ()

## Protected Member Functions

| AdvancedLinearInterpolateImageFunction ()=default
| ~AdvancedLinearInterpolateImageFunction () override=default

## Private Member Functions

void | EvaluateValueAndDerivativeOptimized (const Dispatch< 2 > &, const ContinuousIndexType &x, OutputType &value, CovariantVectorType &deriv) const
void | EvaluateValueAndDerivativeOptimized (const Dispatch< 3 > &, const ContinuousIndexType &x, OutputType &value, CovariantVectorType &deriv) const
void | EvaluateValueAndDerivativeOptimized (const DispatchBase &, const ContinuousIndexType &x, OutputType &value, CovariantVectorType &deriv) const
void | EvaluateValueAndDerivativeUnOptimized (const ContinuousIndexType &, OutputType &, CovariantVectorType &) const

## Member Typedef Documentation

## ConstPointer

template<class TInputImage, class TCoordRep = double>

using itk::AdvancedLinearInterpolateImageFunction< TInputImage, TCoordRep >::ConstPointer = SmartPointer<const Self>

Definition at line 73 of file itkAdvancedLinearInterpolateImageFunction.h.

## ContinuousIndexValueType

template<class TInputImage, class TCoordRep = double>

using itk::AdvancedLinearInterpolateImageFunction< TInputImage, TCoordRep >::ContinuousIndexValueType = typename ContinuousIndexType::ValueType

Definition at line 102 of file itkAdvancedLinearInterpolateImageFunction.h.

## CovariantVectorType

template<class TInputImage, class TCoordRep = double>

using itk::AdvancedLinearInterpolateImageFunction< TInputImage, TCoordRep >::CovariantVectorType = CovariantVector<OutputType, Self::ImageDimension>

Derivative typedef support

Definition at line 105 of file itkAdvancedLinearInterpolateImageFunction.h.

## InputImageSpacingType

template<class TInputImage, class TCoordRep = double>

using itk::AdvancedLinearInterpolateImageFunction< TInputImage, TCoordRep >::InputImageSpacingType = typename InputImageType::SpacingType

Definition at line 86 of file itkAdvancedLinearInterpolateImageFunction.h.

## Pointer

template<class TInputImage, class TCoordRep = double>

using itk::AdvancedLinearInterpolateImageFunction< TInputImage, TCoordRep >::Pointer = SmartPointer<Self>

Definition at line 72 of file itkAdvancedLinearInterpolateImageFunction.h.

## Self

template<class TInputImage, class TCoordRep = double>

using itk::AdvancedLinearInterpolateImageFunction< TInputImage, TCoordRep >::Self = AdvancedLinearInterpolateImageFunction

Standard class typedefs.

Definition at line 70 of file itkAdvancedLinearInterpolateImageFunction.h.

## Superclass

template<class TInputImage, class TCoordRep = double>

using itk::AdvancedLinearInterpolateImageFunction< TInputImage, TCoordRep >::Superclass = LinearInterpolateImageFunction<TInputImage, TCoordRep>

Definition at line 71 of file itkAdvancedLinearInterpolateImageFunction.h.

## Constructor & Destructor Documentation

## AdvancedLinearInterpolateImageFunction()

template<class TInputImage, class TCoordRep = double>

itk::AdvancedLinearInterpolateImageFunction< TInputImage, TCoordRep >::AdvancedLinearInterpolateImageFunction | ( |  | ) |

protected default

## ~AdvancedLinearInterpolateImageFunction()

template<class TInputImage, class TCoordRep = double>

itk::AdvancedLinearInterpolateImageFunction< TInputImage, TCoordRep >::~AdvancedLinearInterpolateImageFunction | ( |  | ) |

override protected default

## Member Function Documentation

## EvaluateDerivativeAtContinuousIndex()

template<class TInputImage, class TCoordRep = double>

CovariantVectorType itk::AdvancedLinearInterpolateImageFunction< TInputImage, TCoordRep >::EvaluateDerivativeAtContinuousIndex | ( | const ContinuousIndexType & | x | ) | const

Method to compute the derivative.

## EvaluateValueAndDerivativeAtContinuousIndex()

template<class TInputImage, class TCoordRep = double>

void itk::AdvancedLinearInterpolateImageFunction< TInputImage, TCoordRep >::EvaluateValueAndDerivativeAtContinuousIndex | ( | const ContinuousIndexType & | x,
|  | OutputType & | value,
|  | CovariantVectorType & | deriv ) const

inline

Method to compute both the value and the derivative.

Definition at line 113 of file itkAdvancedLinearInterpolateImageFunction.h.

## EvaluateValueAndDerivativeOptimized() [1/3]

template<class TInputImage, class TCoordRep = double>

void itk::AdvancedLinearInterpolateImageFunction< TInputImage, TCoordRep >::EvaluateValueAndDerivativeOptimized | ( | const Dispatch< 2 > & | ,
|  | const ContinuousIndexType & | x,
|  | OutputType & | value,
|  | CovariantVectorType & | deriv ) const

private

Method to compute both the value and the derivative. 2D specialization.

## EvaluateValueAndDerivativeOptimized() [2/3]

template<class TInputImage, class TCoordRep = double>

void itk::AdvancedLinearInterpolateImageFunction< TInputImage, TCoordRep >::EvaluateValueAndDerivativeOptimized | ( | const Dispatch< 3 > & | ,
|  | const ContinuousIndexType & | x,
|  | OutputType & | value,
|  | CovariantVectorType & | deriv ) const

private

Method to compute both the value and the derivative. 3D specialization.

## EvaluateValueAndDerivativeOptimized() [3/3]

template<class TInputImage, class TCoordRep = double>

void itk::AdvancedLinearInterpolateImageFunction< TInputImage, TCoordRep >::EvaluateValueAndDerivativeOptimized | ( | const DispatchBase & | ,
|  | const ContinuousIndexType & | x,
|  | OutputType & | value,
|  | CovariantVectorType & | deriv ) const

inline private

Method to compute both the value and the derivative. Generic.

Definition at line 149 of file itkAdvancedLinearInterpolateImageFunction.h.

## EvaluateValueAndDerivativeUnOptimized()

template<class TInputImage, class TCoordRep = double>

void itk::AdvancedLinearInterpolateImageFunction< TInputImage, TCoordRep >::EvaluateValueAndDerivativeUnOptimized | ( | const ContinuousIndexType & | ,
|  | OutputType & | ,
|  | CovariantVectorType & | ) const

inline private

Method to compute both the value and the derivative. Generic.

Definition at line 160 of file itkAdvancedLinearInterpolateImageFunction.h.

## GetClassName()

template<class TInputImage, class TCoordRep = double>

virtual const char * itk::AdvancedLinearInterpolateImageFunction< TInputImage, TCoordRep >::GetClassName | ( |  | ) | const

virtual

Run-time type information (and related methods).

Reimplemented in elastix::LinearInterpolator< TElastix >.

## ITK_DISALLOW_COPY_AND_MOVE()

template<class TInputImage, class TCoordRep = double>

itk::AdvancedLinearInterpolateImageFunction< TInputImage, TCoordRep >::ITK_DISALLOW_COPY_AND_MOVE | ( | AdvancedLinearInterpolateImageFunction< TInputImage, TCoordRep > |  | ) |

## itkStaticConstMacro()

template<class TInputImage, class TCoordRep = double>

itk::AdvancedLinearInterpolateImageFunction< TInputImage, TCoordRep >::itkStaticConstMacro | ( | ImageDimension | ,
|  | unsigned int | ,
|  | Superclass::ImageDimension | )

Dimension underlying input image.

## New()

template<class TInputImage, class TCoordRep = double>

Pointer itk::AdvancedLinearInterpolateImageFunction< TInputImage, TCoordRep >::New | ( |  | ) |

static

Method for creation through the object factory.

Generated on 1768596610 for elastix by 1.15.0 |